CREATE PROCEDURE dbo.IncidentInMemory_GetIncidentInMemoryByBeat
(
@BeatID INT
)
WITH NATIVE_COMPILATION, SCHEMABINDING, EXECUTE AS OWNER
AS
BEGIN ATOMIC
WITH (TRANSACTION ISOLATION LEVEL=SNAPSHOT, LANGUAGE=N'us_english')

	SELECT
		IncidentID,
		IncidentNumber,
		LocalCrimeReportingCode,
		IncidentDate,
		Beat,
		LocationID
	FROM
		PoliceData.IncidentInMemory
	WHERE
		Beat = @BeatID;

END
GO

CREATE PROCEDURE dbo.IncidentInMemory_GetIncidentInMemoryByLocalCrimeReportingCode
(
@LocalCrimeReportingCode VARCHAR(5)
)
WITH NATIVE_COMPILATION, SCHEMABINDING, EXECUTE AS OWNER
AS
BEGIN ATOMIC
WITH (TRANSACTION ISOLATION LEVEL=SNAPSHOT, LANGUAGE=N'us_english')

	SELECT
		IncidentNumber,
		LocalCrimeReportingCode,
		IncidentDate
	FROM PoliceData.IncidentInMemory
	WHERE LocalCrimeReportingCode = @LocalCrimeReportingCode;

END
GO

CREATE PROCEDURE dbo.IncidentInMemory_AddIncidentInMemory
(
@IncidentID INT,
@IncidentNumber VARCHAR(19),
@LocalCrimeReportingCode VARCHAR(5),
@IncidentDate DATETIME,
@Beat INT
)
WITH NATIVE_COMPILATION, SCHEMABINDING, EXECUTE AS OWNER
AS
BEGIN ATOMIC
WITH (TRANSACTION ISOLATION LEVEL=SNAPSHOT, LANGUAGE=N'us_english')

	INSERT INTO PoliceData.IncidentInMemory
	(
		IncidentID,
		IncidentNumber,
		LocalCrimeReportingCode,
		IncidentDate,
		Beat
	)
	VALUES
	(
		--NEXT VALUE FOR [PoliceData].[IncidentInMemorySequence],	<-- not allowed!
		@IncidentID,
		@IncidentNumber,
		@LocalCrimeReportingCode,
		@IncidentDate,
		@Beat
	);

END
GO